#include <gcroot.h>
#using <mscorlib.dll>
#using <System.dll>
#using "..\..\bin\Debug\VLC.WPF.VideoOutputController.dll"

#include "config.h"
#include <vlc\vlc.h>
#include <vlc_common.h>
#include <vlc\vout.h>
#include <vlc\intf.h>
#include <vlc\aout.h>

using namespace VLC::WPF;
using namespace System;
using namespace System::Runtime::InteropServices;

/*****************************************************************************
 * Local prototypes.
 *****************************************************************************/
static int  OpenVideo		( vlc_object_t * );
static void CloseVideo		( vlc_object_t * );

static int  InitVideo		( vout_thread_t * );
static void EndVideo		( vout_thread_t * );
static int  ManageVideo		( vout_thread_t * );
static void RenderVideo		( vout_thread_t *, picture_t * );
static void DisplayVideo	( vout_thread_t *, picture_t * );
static int ControlVideo		( vout_thread_t *, int , va_list );

static int Control( vout_thread_t *p_vout, int i_query, va_list args );

gcroot<VideoOutputController^> p_video_output;

struct vout_sys_t
{
	unsigned char *p_pic_buffer;
};